var global_document_url = global_document_url || null;
var global_offset = 0;

function vid_mate_get_video_id(url)
{
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) 
	{
		return null;
	}

	//https://drive.google.com/file/d/0B0VS8-zQCcJmX2FwdlpWTWxRNGs/view
	if(-1 == vid_mate_url.indexOf("/file/d/0B0VS8"))
	{
		return null;
	}
	
	var video_id = null;
	video_id = cutstr(vid_mate_url, "/file/d/", "/view");
	if(video_id)
	{
		return video_id;
	}

	return null;
}

function vid_mate_check() {
	if (vid_mate_get_video_id() == null) {
		vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_get_video_info(url)
{
    vid_mate_setParseMsg(10, 20, 'Start Analytics');
	var vid_mate_video_id = vid_mate_get_video_id(url);
	vid_mate_setParseMsg(20, 60, 'Get Video Info');
	global_document_url = url;
	
	try {
		vid_mate_setParseMsg(20, 60, 'Get Video Info... ...');

		var referer = url;
		var cookie = "";
		if(window.vbrowser.httpGetCookie)
		{
			cookie = window.vbrowser.httpGetCookie(global_document_url);
		}
		else
		{
			cookie = document.cookie;
		}

		var userAgent = "Mozilla/5.0 (Linux; Android 4.3; Build/KRT16M) AppleWebKit/517.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36";
		var method = "get";
		var data = "";
		vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
	} catch (e) {
		vid_mate_error_default('kdrama 1');
		return null;
	}
}

function vid_mate_video_analytics(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('vm_content is empty');
		return null;
	}
	
	var videoUrl = "";
	var videoImg = "";
    var video_title = "";
	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "kdrama";
	rtn_video.js_ver = "1.01";
	rtn_video.js_info = "20160510:first ver";
	rtn_video.id = vid_mate_get_video_id(global_document_url);	
	video_title = cutstr(vm_content, "[\"title\",\"", "\"]");
	if(video_title)
	{
		video_title = video_title.trim();
	}
	else
	{
		video_title = "kdrama mp4";
	}
	
	rtn_video.title = video_title;
	videoImg = cutstr(vm_content, "og:image\" content=\"", "\"");
	rtn_video.picture_default = videoImg;
    rtn_video.picture_big = videoImg;
	var videos = cutstr(vm_content, "[\"fmt_stream_map\",\"", "\"]");
	if(!videos || videos.length < 60)
	{
		vid_mate_error_default('Not find video source');
		return null;
	}
	
	var arr = videos.split(',');
	for(var i=0; i<arr.length; i++)
	{
		var href = arr[i];
		var arr_video = href.split('|');
		if(arr_video.length < 2)
		{
			continue;
		}
		
		var itag = arr_video[0];
		if(itag == '43')
		{
			continue;
		}
		
		var video_url = arr_video[1];
		video_url = decodeURIComponent(video_url);
		//unicode
		video_url = eval("'" + video_url + "'");
		var tmp_format = "mp4";
		var tmp_title = "640x360(MP4 360p)";
		if(itag == '34')
		{
			tmp_format = 'FLV';
			tmp_title = "640x360(FLV 360p)";
		}
		
		var tmp_video_file = new vid_mate_video_file();		
		tmp_video_file.url = video_url;
		tmp_video_file.format = tmp_format;
		tmp_video_file.title = tmp_title;
		tmp_video_file.f_id = rtn_video.id+"_"+ itag;
		rtn_video.files.push(tmp_video_file);
	}
	
	if(rtn_video.files.length <= 0)
	{
		vid_mate_error_default('Not find video source');
		return null;
	}
	
	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}

function cutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p1 = content.indexOf(prefix);
	if(-1 == p1)
	{
		return "";
	}
	p1 += prefix_len;
	var p2 = content.indexOf(suffix, p1);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1, p2);
}