var global_document_url = global_document_url || null;
var global_offset = 0;
var global_video_id = null;
var global_video_title = "";
var global_video_img = "";
var global_video = null;

function vid_mate_get_video_id(url)
{
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}
	
	var matched1 = (/video.mthai.com\/channel\/[a-zA-Z0-9]+\/player\/[0-9]{10}.html$/i);
	var matched2 = (/video.mthai.com\/[a-zA-Z0-9]+\/player\/[0-9]{10}.html$/i);
	
	if(!matched1.test(vid_mate_url) && !matched2.test(vid_mate_url))
	{
		return null;
	}
	
	var video_id = cutstr(vid_mate_url, "/player/", ".html");
	if(video_id)
	{
		return video_id;
	}
	
	return null;
}

function vid_mate_check() {
	if (vid_mate_get_video_id() == null) 
	{
		vid_mate_set_canDownload(false);
		return false;
	} 
	else 
	{
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_get_video_info(url)
{
    vid_mate_setParseMsg(10, 20, 'Start Analytics');
	global_video_id = vid_mate_get_video_id(url);
	global_document_url = url;
	try {
		vid_mate_setParseMsg(20, 60, 'Get Video Info... ...');
		var referer = url;
		var cookie = "";
		if(window.vbrowser.httpGetCookie)
		{
			cookie = window.vbrowser.httpGetCookie(global_document_url);
		}
		else
		{
			cookie = document.cookie;
		}
		
		var userAgent = "Mozilla/5.0 (Linux; Android 4.3; Build/KRT16M) AppleWebKit/517.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36";
		var method = "get";
		var data = "";
		vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
	} catch (e) {
		vid_mate_error_default('mthai 1');
		return null;
	}
}

function vid_mate_video_analytics(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('vm_content is empty');
		return null;
	}
	
	var tmp_content = vm_content;
	if(-1 == tmp_content.indexOf("var sources_temp_akamai =") || -1 != tmp_content.indexOf("var sources_temp_akamai = null"))
	{
		if(-1 == tmp_content.indexOf("var sources_temp =") || -1 != tmp_content.indexOf("var sources_temp = null"))
		{
			vid_mate_error_default('no mp4 source.');
			return null;
		}
		
		vm_content = cutstr(vm_content, "var sources_temp =", ";");
	}
	else
	{
		vm_content = cutstr(vm_content, "var sources_temp_akamai =", ";");
	}
	
	var data = null;
	try 
	{
		data = eval('('+vm_content+')');
	}
	catch (e) 
	{
		vid_mate_error_default('mthai data eval fail:is not json');
		return null;
	}

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = 'mthai';
	rtn_video.js_ver  = "1.01";
	rtn_video.js_info = "first version";
	global_video_img = "http://video.mthai.com/thumbnail/" + global_video_id + ".jpg";

	var tmp_title = cutstr(tmp_content, "<title>", "</title>");
	if(tmp_title)
	{
		tmp_title = tmp_title.replace("\n", "");
		tmp_title = tmp_title.trim();
	}
	else
	{
		tmp_title = "mthai video";
	}

	rtn_video.title = tmp_title;
	if(global_video_img)
	{
		rtn_video.picture_default = global_video_img;
		rtn_video.picture_big = global_video_img;
	}

	rtn_video.id = global_video_id;
	rtn_video.url = global_document_url;
	for(var i = 0; i < data.length; i++)
	{
		if(-1 != data[i].file.indexOf(".m3u8"))
		{
			continue;
		}
		
		var tmp_video_file = new vid_mate_video_file();
		tmp_video_file.url = data[i].file;
		tmp_video_file.f_id = global_video_id + '_' + i;
		tmp_video_file.format = 'mp4';
		tmp_video_file.title = "mp4(" + data[i].label + ")" ;
		rtn_video.files.push(tmp_video_file);
	}

	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}

function cutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p1 = content.indexOf(prefix);
	if(-1 == p1)
	{
		return "";
	}
	p1 += prefix_len;
	var p2 = content.indexOf(suffix, p1);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1, p2);
}
